#!/usr/bin/perl --
use CGI::Carp qw(fatalsToBrowser);

###############################################################################
# Admin_Center_Update_Convert.pl                                              #
###############################################################################
# Admin Center Update                                                         #
# Adds quite a few options to the Admin Center		          		            #
# Version:        1.3 final (YaBB 2.0/2.1)                                    #
# Released:       March 31, 2006                                              #
# =========================================================================== #
# Written by Curtiss Grymala for the YaBB community                           #
###############################################################################
# Convert Variables From Older Versions of Admin Center Update to the new     #
# versions of those variables.  This script should only be executed by	 		#
# people upgrading from versions earlier than 0.4 beta to version 0.4 beta		#
###############################################################################

push(@INC, "./Modules");

require "Paths.pl";
require "$sourcedir/Subs.pl";
require "$sourcedir/System.pl";
require "$sourcedir/Load.pl";
require "$sourcedir/DateTime.pl";
if (-e "$vardir/acup_reg.txt") { require "$vardir/acup_reg.txt"; }
if (-e "$vardir/acup_prof.txt") { require "$vardir/acup_prof.txt"; }
if (-e "$vardir/acup_dim.txt") { require "$vardir/acup_dim.txt"; }
LoadLanguage("AdminCenter_Update");
if($FORM{'PickPurposeChoice'} == 1) {
&ConvertRegVariables;
&ConvertProfVariables;
&ConvertDimVariables;
&output;
exit;
}
elsif($FORM{'PickPurposeChoice'} == 2) {
&ConvertProfBugs;
&output_prof_bugs;
exit;
}
else {
&PickPurpose;
exit;
}

## Function to choose which version you are upgrading ##
sub PickPurpose {

	if($yySetCookies1 || $yySetCookies2) { print header(-status=>"200 OK", -cookie=>[$yySetCookies1, $yySetCookies2], -charset=>$yycharset); }
	else { print header(-status=>"200 OK", -charset=>$yycharset); }
print qq~
<!DOCTYPE html PUBLIC "-//W3C//DTD Xhtml 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>Admin Center Update Variable Conversion</title>
<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />
</head>
<body style="font-family: verdana; font-size: 12px; font-weight: bold;">
<form name="PickPurpose" action="ACUpdateConverter.pl" method="POST">
<table cellspacing="0" cellpadding="3" border="1" align="center" bordercolor="#000000" style="width:805px;">
	<tr>
		<td>
			From Which Version Are You Converting?
		</td>
		<td>
			<input type="radio" name="PickPurposeChoice" value="1" />&nbsp;&nbsp;0.1 beta or 0.2 beta
			<br />
			<input type="radio" name="PickPurposeChoice" value="2" />&nbsp;&nbsp;0.3 beta
		</td>
	</tr>
	<tr>
		<td colspan="2" align="center">
			<input type="submit" name="submit" value="Convert" />
		</td>
	</tr>
</table>
</body>
</html>
~;
exit;
}

## Function to convert the acup_reg.txt variables from 0.1/0.2 format to later format ##
sub ConvertRegVariables {

my @old_var_names = ($acup_reg1, $acup_reg2, $acup_reg3, $acup_reg4, $acup_reg5, $acup_reg6, $acup_reg7, $acup_reg8, $acup_reg9, $acup_reg10, $acup_reg12, $acup_reg13, $acup_reg14, $acup_reg17);
my @new_var_names = ('reg_RealName', 'reg_Gender', 'reg_BirthDate', 'reg_Location', 'reg_ICQ', 'reg_AIM', 'reg_YIM', 'reg_MSN', 'reg_GTalk', 'reg_WebInfo', 'reg_UserText', 'reg_Sig', 'reg_TimeSet', 'reg_Template');
my @var_comments = (" # User's real name/display name", " # Gender", " # Birthday", " # Location", " # ICQ", " # AIM", " # YIM", " # MSN", " # Google Talk", " # Website Information", " # UserText", " # Signature", " # Time Settings", " # Template Selector");

		$reg_output = qq~###############################################################################
# acup_reg.txt                                                                #
###############################################################################
# Admin Center Update                                                         #
# Variable Values For Registration Options                                    #
# Version:        0.4 Beta (YaBB 2.0/2.1)                                     #
# Released:       January 27, 2006                                            #
# =========================================================================== #
# Written by Curtiss Grymala for the YaBB community                           #
###############################################################################
# Admin Center Update Registration Variable Values                            #
###############################################################################
# The items with values of 1 below will be shown on the registration page     #
# Items with a value of 2 will be required.                                   #
# Items with a value of 0 will not be shown                                   #
###############################################################################

~;

$i = 0;
while($i <= 13) {
	$reg_output .= qq~\$@new_var_names[$i] = \'@old_var_names[$i]\';@var_comments[$i]
~;
	$i = $i + 1;
}

	$reg_output .= q~
1;~;

	fopen(ACUP_REGSETTINGS, ">$vardir/acup_reg.txt");
	if(print ACUP_REGSETTINGS $reg_output) {
		$reg_ok = 1;
	}
	fclose(ACUP_REGSETTINGS);

}

## Function to convert acup_prof.txt variables from 0.1/0.2 format to current format ## 
sub ConvertProfVariables {
	my @old_var_names = ($acup_prof1, $acup_prof2, $acup_prof3, $acup_prof4, $acup_prof5, $acup_prof6, $acup_prof_val1, $acup_prof_val2, $acup_prof_val3, $acup_prof_val4, $acup_prof_val5, $acup_prof_val5, $acup_prof_val6);
	my @new_var_names = ('default_Location', 'default_HideMail', 'default_UserPic', 'default_IMNotify', 'default_IMPopup', 'default_IMsPop', 'default_Location_val', 'default_HideMail_val', 'default_UserPic_val', 'default_IMNotify_val', 'default_IMPopup_val', 'default_IMsPop_val');
	my @var_comments = (' # Location', ' # Hide Email', ' # User Pic/Avatar', ' # PM Notification', ' # PM Popup Shows In New Window', ' # Enable PM Popup', ' # Default Value For Location', ' # Default Value For Hide Email', ' # Default Value For User Pic/Avatar', ' # Default Value For PM Notification', ' # Default Value For PM Popup Shows In New Window', ' # Default Value For Enable PM Popup');

	$prof_output = qq~###############################################################################
# acup_prof.txt                                                               #
###############################################################################
# Admin Center Update                                                         #
# Variables For Default Profile Values                                        #
# Version:        0.4 Beta (YaBB 2.0/2.1)                                     #
# Released:       January 27, 2006                                            #
# =========================================================================== #
# Written by Curtiss Grymala for the YaBB community                           #
###############################################################################
# Admin Center Update Default Profile Values                                  #
###############################################################################
# The items with values of 1 in the first section below will use the default  #
# values set in the second section below.                                     #
###############################################################################

~;

	$i = 0;
	while($i <= 11) {
		if($i == 6) {
			$prof_output .= qq~
###############################################################################

~;
		}
		if($i == 10 || $i == 11) {
			if(@old_var_names[$i] == 1) {
				@old_var_names[$i] = "on";
			}
			else {
				@old_var_names[$i] = "";
			}
		}
		$prof_output .= qq~\$@new_var_names[$i] = \'@old_var_names[$i]\';@var_comments[$i]
~;
		$i = $i + 1;
	}
	
	$prof_output .= q~
1;~;

	fopen(ACUP_PROFSETTINGS, ">$vardir/acup_prof.txt");
	if(print ACUP_PROFSETTINGS $prof_output) {
		$prof_ok = 1;
	}
	fclose(ACUP_PROFSETTINGS);

}

## Function to convert acup_dim.txt variables from 0.1/0.2 format to current format ##
sub ConvertDimVariables {

	my @old_var_names = ($acup_dim_val1, $acup_dim_val2, $message_width, $message_height, $recent_post_val, $button_area_width);
	my @new_var_names = (dim_RestrictSig, dim_SigHeight, message_width, message_height, recent_post_val, button_area_width);
	my @var_comments = (' # Restrict Height of Sig Block', ' # Max-Height of Sig Block', ' # Width (in pixels) of Message Posting Area', ' # Height of Message Posting Area', ' # Number of recent posts to show', ' # Width of the yabbc button area on Post page');

	$dim_output =  qq~###############################################################################
# acup_dim.txt                                                                #
###############################################################################
# Admin Center Update                                                         #
# Various Width/Height Dimensions, etc.                                       #
# Version:        0.4 Beta (YaBB 2.0/2.1)                                     #
# Released:       January 27, 2006                                            #
# =========================================================================== #
# Written by Curtiss Grymala for the YaBB community                           #
###############################################################################
# Admin Center Update Various Dimension Definitions                           #
###############################################################################

~;

	$i = 0;
	while($i <= 5) {
		$dim_output .= qq~\$@new_var_names[$i] = \'@old_var_names[$i]\';@var_comments[$i]
~;	
		$i = $i + 1;
	}

	$dim_output .= q~
1;~;

	fopen(ACUP_DIMSETTINGS, ">$vardir/acup_dim.txt");
	if(print ACUP_DIMSETTINGS $dim_output) {
		$dim_ok = 1;
	}
	fclose(ACUP_DIMSETTINGS);

}

## Function that prints the results of your conversion from 0.1/0.2 beta ##
sub output {
	if($yySetCookies1 || $yySetCookies2) { print header(-status=>"200 OK", -cookie=>[$yySetCookies1, $yySetCookies2], -charset=>$yycharset); }
	else { print header(-status=>"200 OK", -charset=>$yycharset); }
	print qq~
	<!DOCTYPE html PUBLIC "-//W3C//DTD Xhtml 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
	<title>Admin Center Update Variable Conversion</title>
	<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />
	</head>
	<body style="font-family: verdana; font-size: 10px;">
	<table cellspacing="0" cellpadding="3" border="1" align="center" bordercolor="#000000" style="width:805px;">
		<tr><td style="color: #fff; background-color: #000; font-family: verdana, arial, sans-serif; font-size: 14px; font-weight: bold;">~;
	if($reg_ok == 1 && $prof_ok == 1 && $dim_ok == 1) {
	print qq~Conversion from old Admin Center Update Variables completed!
	<br /><span style="font-size: 11px; color: #f00; font-style: italic;">Please delete ACUpdateConverter.pl from your server now, in order to avoid overwriting your variable files again.~;
	}
	else {
		print qq~ERROR!
		<br /><span style="font-size: 12px; color: #fff; font-style: italic;">There was an error overwriting one or more of your variable files.  You will need to manually copy the code within the textareas below, and paste it into the appropriate variable file yourself.</span>
		<br /><span style="font-size: 11px; color: #f00;">The following file(s) generated errors:~;
		if($reg_ok ne 1) {
			print qq~<br />$vardir/acup_reg.txt~;
		}
		if($prof_ok ne 1) {
			print qq~<br />$vardir/acup_prof.txt~;
		}
		if($dim_ok ne 1) {
			print qq~<br />$vardir/acup_dim.txt~;
		}
		print qq~</span>~;
	}
	print qq~</td></tr>
	<tr><td style="color: #000; background-color: #fff; font-family: verdana, arial, sans-serif; font-size: 11px;">Your old variable files were succesfully overwritten with the following new files:</td></tr>
	<tr><td style="color: #000; background-color: #fff; font-family: courier, mono-space; font-size: 11px;">$vardir/acup_reg.txt:</td></tr>
	<tr><td><textarea cols="112" rows="20" style="width:800px; height:300px; font-family: courier, mono-space; font-size: 10px;">$reg_output</textarea></td></tr>
	<tr><td style="color: #000; background-color: #fff; font-family: courier, mono-space; font-size: 11px;">$vardir/acup_prof.txt:</td></tr>
	<tr><td><textarea cols="112" rows="20" style="width:800px; height:300px; font-family: courier, mono-space; font-size: 10px;">$prof_output</textarea></td></tr>
	<tr><td style="color: #000; background-color: #fff; font-family: courier, mono-space; font-size: 11px;">$vardir/acup_dim.txt:</td></tr>
	<tr><td><textarea cols="112" rows="20" style="width:800px; height:300px; font-family: courier, mono-space; font-size: 10px;">$dim_output</textarea></td></tr>
	</table>
	</body>
	</html>~;
exit;
}

## Function to fix bugs present in 0.4 ##
sub ConvertProfBugs {

	my @var_names = ('default_Location', 'default_HideMail', 'default_UserPic', 'default_IMNotify', 'default_IMPopup', 'default_IMsPop', 'default_Location_val', 'default_HideMail_val', 'default_UserPic_val', 'default_IMNotify_val', 'default_IMPopup_val', 'default_IMsPop_val');
	my @var_comments = (' # Location', ' # Hide Email', ' # User Pic/Avatar', ' # PM Notification', ' # PM Popup Shows In New Window', ' # Enable PM Popup', ' # Default Value For Location', ' # Default Value For Hide Email', ' # Default Value For User Pic/Avatar', ' # Default Value For PM Notification', ' # Default Value For PM Popup Shows In New Window', ' # Default Value For Enable PM Popup');

		$output_profbug = qq~###############################################################################
# acup_prof.txt                                			                        #
###############################################################################
# Admin Center Update                                                         #
# Variables For Default Profile Values														#
# Version:        0.4 Beta (YaBB 2.0/2.1)                                     #
# Released:       January 27, 2006                                            #
# =========================================================================== #
# Written by Curtiss Grymala for the YaBB community                           #
###############################################################################
# Admin Center Update Default Profile Values			                           #
###############################################################################
# The items with values of 1 below will use the default set in the next 		#
# section below.																					#
###############################################################################

~;

$i = 0;
while ($i <= 11) {

	if($i == 6) {
		$output_profbug .= qq~
###############################################################################

~;
	}
	
	if($i == 10 || $i == 11) {
		if(${@var_names[$i]} == 1) {
			${@var_names[$i]} = "on";
		}
		else {
			${@var_names[$i]} = "";
		}
	}

$output_profbug .= qq~\$@var_names[$i] = \'${@var_names[$i]}\';@var_comments[$i]
~;
$i = $i + 1;
}

$output_profbug .= q~
1;~;

	fopen(ACUP_PROFSETTINGS, ">$vardir/acup_prof.txt");
	if(print ACUP_PROFSETTINGS $output_profbug) {
		$prof_ok = 1;
	}
	fclose(ACUP_PROFSETTINGS);

}

## Function to print results of conversion from 0.4 beta ##
sub output_prof_bugs {

	if($yySetCookies1 || $yySetCookies2) { print header(-status=>"200 OK", -cookie=>[$yySetCookies1, $yySetCookies2], -charset=>$yycharset); }
	else { print header(-status=>"200 OK", -charset=>$yycharset); }
	print qq~
	<!DOCTYPE html PUBLIC "-//W3C//DTD Xhtml 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
	<title>Admin Center Update Variable Conversion</title>
	<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />
	</head>
	<body style="font-family: verdana; font-size: 10px;">
	<table cellspacing="0" cellpadding="3" border="1" align="center" bordercolor="#000000" style="width:805px;">
		<tr><td style="color: #fff; background-color: #000; font-family: verdana, arial, sans-serif; font-size: 14px; font-weight: bold;">~;
	if($prof_ok == 1) {
	print qq~Conversion from old Admin Center Update Variables completed!
	<br /><span style="font-size: 11px; color: #f00; font-style: italic;">Please delete ACUpdateConverter.pl from your server now, in order to avoid overwriting your variable files again.~;
	}
	else {
		print qq~ERROR!
		<br /><span style="font-size: 12px; color: #fff; font-style: italic;">There was an error overwriting one or more of your variable files.  You will need to manually copy the code within the textareas below, and paste it into the appropriate variable file yourself.</span>
		<br /><span style="font-size: 11px; color: #f00;">The following file(s) generated errors:~;
		if($prof_ok ne 1) {
			print qq~<br />$vardir/acup_prof.txt~;
		}
		print qq~</span>~;
	}
	print qq~</td></tr>
	<tr><td style="color: #000; background-color: #fff; font-family: verdana, arial, sans-serif; font-size: 11px;">Your old variable files were succesfully overwritten with the following new files:</td></tr>
	<tr><td style="color: #000; background-color: #fff; font-family: courier, mono-space; font-size: 11px;">$vardir/acup_prof.txt:</td></tr>
	<tr><td><textarea cols="112" rows="20" style="width:800px; height:300px; font-family: courier, mono-space; font-size: 10px;">$output_profbug</textarea></td></tr>
	<tr><td><textarea cols="112" rows="20" style="width:800px; height:300px; font-family: courier, mono-space; font-size: 10px;">$dim_output</textarea></td></tr>
	</table>
	</body>
	</html>~;
exit;

}

1;